#define YYBYACC 1
#line 2 "bc.y"

/* bc.y: The grammar for a POSIX compatable bc processor with some
         extensions to the language. */

/*  This file is part of bc written for MINIX.
    Copyright (C) 1991, 1992, 1993, 1994 Free Software Foundation, Inc.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License , or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING.  If not, write to
    the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

    You may contact the author by:
       e-mail:  phil@cs.wwu.edu
      us-mail:  Philip A. Nelson
                Computer Science Department, 9062
                Western Washington University
                Bellingham, WA 98226-9062
       
*************************************************************************/

static const char SSIRCSid[]="$Header: //P/support/interix_2.2_sp1/src/bc/bc-1.03/RCS/bc.c,v 1.1 1998/10/07 18:23:57 SSI_DEV+mark Exp $";

#include "bcdefs.h"
#include "global.h"
#include "proto.h"
#line 41 "bc.y"
typedef union {
	char	 *s_value;
	char	  c_value;
	int	  i_value;
	arg_list *a_value;
       } YYSTYPE;
#line 46 "y.tab.c"
#define NEWLINE 257
#define AND 258
#define OR 259
#define NOT 260
#define STRING 261
#define NAME 262
#define NUMBER 263
#define MUL_OP 264
#define ASSIGN_OP 265
#define REL_OP 266
#define INCR_DECR 267
#define Define 268
#define Break 269
#define Quit 270
#define Length 271
#define Return 272
#define For 273
#define If 274
#define While 275
#define Sqrt 276
#define Else 277
#define Scale 278
#define Ibase 279
#define Obase 280
#define Auto 281
#define Read 282
#define Warranty 283
#define Halt 284
#define Last 285
#define Continue 286
#define Print 287
#define Limits 288
#define UNARY_MINUS 289
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   10,   10,   10,   11,   11,   11,   11,   12,
   12,   12,   12,   12,   12,   15,   15,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   16,   17,   18,
   19,   13,   20,   13,   22,   23,   13,   13,   25,   13,
   24,   24,   26,   26,   21,   27,   21,   28,   14,    5,
    5,    6,    6,    6,    7,    7,    7,    7,    8,    8,
    9,    9,    9,    9,    4,    4,    2,    2,   29,    1,
   30,    1,   31,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    3,    3,    3,    3,    3,    3,
};
short yylen[] = {                                         2,
    0,    2,    2,    1,    2,    0,    1,    3,    2,    0,
    1,    2,    3,    2,    3,    1,    2,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    4,    0,    0,    0,
    0,   13,    0,    7,    0,    0,    7,    3,    0,    3,
    1,    3,    1,    1,    0,    0,    3,    0,   11,    0,
    1,    0,    3,    3,    1,    3,    3,    5,    0,    1,
    1,    3,    3,    5,    0,    1,    0,    1,    0,    4,
    0,    4,    0,    4,    2,    3,    3,    3,    3,    3,
    2,    1,    1,    3,    4,    2,    2,    4,    4,    4,
    3,    1,    4,    1,    1,    1,    1,
};
short yydefred[] = {                                      1,
    0,    0,    0,   21,    0,   83,    0,    0,   22,   24,
    0,    0,   28,    0,   35,    0,    0,   94,   95,    0,
   18,   25,   97,   23,   39,   19,    0,    0,    0,    0,
    0,    2,    0,   16,    4,    7,    5,   17,    0,    0,
    0,    0,   96,   86,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   81,    0,    0,    0,   11,   71,
   73,    0,    0,    0,    0,    0,   69,   87,    3,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   91,   43,    0,   40,    0,   84,
    0,    0,   38,    0,    0,    0,    0,    0,    0,    0,
    0,    8,    0,   85,    0,   93,    0,    0,    0,   88,
   27,    0,    0,   33,    0,   89,   90,    0,   13,   15,
    0,    0,    0,   62,    0,    0,    0,    0,    0,   29,
    0,    0,   42,    0,   56,    0,    0,    0,    0,    0,
   64,    0,    0,    0,   46,   34,   37,    0,   48,   58,
   30,    0,    0,    0,    0,   47,   53,   54,    0,    0,
   49,   31,    0,   32,
};
short yydgoto[] = {                                       1,
   30,   79,   31,  113,  108,  149,  109,   73,   74,   32,
   33,   58,   34,   35,   59,   48,  138,  155,  163,  131,
  146,   50,  132,   88,   54,   89,  152,  154,  101,   94,
   95,
};
short yysindex[] = {                                      0,
   -7,   25,  147,    0,  -13,    0, -227, -226,    0,    0,
    4,    6,    0,    7,    0,    8,    9,    0,    0,   10,
    0,    0,    0,    0,    0,    0,  147,  147,   58,  637,
 -233,    0,  -45,    0,    0,    0,    0,    0,   51,  212,
  147,  -37,    0,    0,   16,  147,  147,   19,  147,   20,
  147,  147,   21,  116,    0,  587,   87,  -57,    0,    0,
    0,  147,  147,  147,  147,  147,    0,    0,    0,   58,
  -10,  637,   22,   -3,  619, -201,  607,  637,   23,  147,
  646,  147,  649,  663,    0,    0,  637,    0,   36,    0,
   58,   87,    0,  147,  147,  -28,  -39,  -82,  -82,  -28,
  147,    0,  126,    0,  244,    0,  -24,   30,   42,    0,
    0,  637,   29,    0,  637,    0,    0,  116,    0,    0,
   51,  666,  -39,    0,   -9,  637,   -4,  -33, -171,    0,
   87,   52,    0,  157,    0, -165,   11,  147, -182,   87,
    0, -184,   12,   40,    0,    0,    0, -201,    0,    0,
    0,   87,  -43,   58,  147,    0,    0,    0,  -56,   59,
    0,    0,   87,    0,
};
short yyrindex[] = {                                      0,
  -44,    0,    0,    0,  402,    0,    0,    0,    0,    0,
    0,  -51,    0,    0,    0,    0,  419,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -52,  -49,
  441,    0,    0,    0,    0,    0,    0,    0,  341,   60,
    0,  458,    0,    0,    0,    0,   65,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -42,
  552,  -18,    0,   66,    0,   68,    0,   69,    0,   53,
    0,    0,    0,    0,    0,    0,   13,    0,   45,    0,
  -50,  -48,    0,    0,    0,  487,  526,  514,  520,  497,
    0,    0,    0,    0,    0,    0,  -20,    0,   70,    0,
    0,  -19,    0,    0,   72,    0,    0,    0,    0,    0,
  547,  570,  530,    0,  552,    1,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -16,   53,  -46,    0,
    0,  -40,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -52,   73,    0,    0,    0,    0,    0,
    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
  906,    0,  108, -118,    0,    0,  -31,    0,    0,    0,
    0,  -36,   27,    0,   17,    0,    0,    0,    0,    0,
    0,    0,    0,    2,    0,    0,    0,    0,    0,    0,
    0,
};
#define YYTABLESIZE 1061
short yytable[] = {                                      52,
  129,   92,   92,   64,   52,   65,   10,   26,   12,   20,
   14,   66,   45,   70,    6,  158,    9,   36,   52,  144,
   55,   66,   61,   55,   57,   61,   40,   57,   38,   40,
   40,   67,   28,   68,   42,   45,  160,   27,   55,   66,
  105,   63,   57,   46,   63,   47,   49,   51,   52,   53,
   43,   18,   19,   41,   66,   76,   44,   23,   80,   82,
  107,   85,  104,  111,   28,   66,  127,   93,  161,   27,
  128,   44,   10,   26,   12,   20,   14,   41,   45,  118,
  103,  134,   52,   38,   52,  129,  102,  130,  135,  136,
  137,  142,  140,   64,  145,   65,  148,   28,  151,  162,
   59,  143,   27,   41,  150,   67,   60,  119,   50,   68,
   51,   65,   36,   65,   44,   29,  153,  159,  120,  133,
    0,    0,    0,    0,    0,    0,   28,    0,    0,    0,
    0,   27,    0,    0,    0,    0,    0,   44,    0,    0,
    0,    0,    0,    0,   66,    0,    0,   29,    0,    0,
    0,    0,    0,    0,    0,   28,    0,  139,    0,    0,
   27,    0,    0,    0,    0,   28,  147,    0,    0,   41,
   27,    0,    0,    0,    0,    0,    0,    0,  156,    0,
   29,   62,    0,    0,    0,    0,   28,    0,    0,  164,
    0,   27,    0,    0,    0,    0,   28,    0,    0,   91,
   91,   27,    0,    0,   10,   26,   12,   20,   14,   29,
   45,   69,    6,  157,    9,   52,   52,    0,  124,   52,
   52,   52,   52,    0,   62,   26,   52,   20,   52,   52,
   52,   52,   52,   52,   52,   52,   55,   52,   52,   52,
   57,   52,   52,   52,   52,   52,   52,   52,    2,  141,
    0,   28,    3,    4,    5,    6,   27,    0,    0,    7,
    8,    9,   10,   11,   12,   13,   14,   15,   16,   44,
   17,   18,   19,    0,   20,   21,   22,   23,   24,   25,
   26,   37,    0,   28,    3,    4,    5,    6,   27,   44,
    0,    7,    0,    9,   10,   11,   12,   13,   14,   15,
   16,   41,   17,   18,   19,    0,   20,   21,   22,   23,
   24,   25,   26,   57,   62,    0,   63,    3,    4,    5,
    6,   41,    0,    0,    7,    0,    9,   10,   11,   12,
   13,   14,   15,   16,    0,   17,   18,   19,    0,   20,
   21,   22,   23,   24,   25,   26,    3,    4,    5,    6,
    0,    0,    0,    7,    0,    9,   10,   11,   12,   13,
   14,   15,   16,    0,   17,   18,   19,    0,   20,   21,
   22,   23,   24,   25,   26,    3,   86,    5,    6,    0,
    0,   75,    7,    0,   75,    3,   11,    5,    6,    0,
    0,   16,    7,   17,   18,   19,   11,   20,    0,   75,
   23,   16,    0,   17,   18,   19,    3,   20,    5,    6,
   23,    0,    0,    7,    0,    0,    3,   11,    5,    6,
    0,    0,   16,    7,   17,   18,   19,   11,   20,    0,
    0,   23,   16,   75,   17,   18,   19,    0,   20,    0,
    0,   23,   92,    0,   92,   92,   92,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   96,
   92,   96,   96,   96,    0,   75,    0,    0,    0,    0,
    0,    3,    0,   71,    6,    0,    0,   96,    7,    0,
    0,   82,   11,   82,   82,   82,    0,   16,    0,   17,
   18,   19,    0,   20,   92,   92,   23,    0,   92,   82,
   92,   92,   92,    3,    0,  125,    6,    0,    0,    0,
    7,   96,   96,    0,   11,    0,   92,    0,    0,   16,
    0,   17,   18,   19,    0,   20,   92,   79,   23,   79,
   79,   79,    0,   82,   82,    0,    0,   80,    0,   80,
   80,   80,    0,   96,    0,   79,    0,    0,    0,    0,
   92,   92,    0,    0,   77,   80,   77,   77,   77,    0,
   78,    0,   78,   78,   78,   82,   76,    0,    0,   76,
   70,    0,   77,   70,    0,    0,    0,    0,   78,   79,
    0,    0,   92,    0,   76,    0,    0,   72,   70,   80,
   72,    0,   92,    0,   92,   92,   92,   75,   75,   75,
    0,    0,    0,    0,    0,   72,   77,    0,    0,    0,
   74,   79,   78,   74,    0,    0,    0,   75,   76,    0,
    0,   80,   70,    0,    0,    0,    0,   90,   74,   64,
    0,   65,    0,    0,    0,    0,    0,    0,   77,   72,
    0,    0,    0,    0,   78,   92,    0,  110,    0,   64,
   76,   65,    0,    0,   70,    0,    0,    0,   92,   92,
   92,   64,   74,   65,    0,   92,   92,   92,   92,    0,
    0,   72,    0,    0,    0,   96,   96,   96,   92,   64,
   66,   65,   96,   96,   96,   96,  114,    0,   64,  116,
   65,   64,    0,   65,   74,   96,    0,   82,   82,   82,
   66,    0,    0,  117,   82,   64,   82,   65,   64,    0,
   65,  106,   66,    0,   92,   92,   92,   82,    0,    0,
    0,   92,    0,   92,    0,    0,    0,    0,    0,    0,
   66,    0,    0,    0,   92,    0,    0,    0,    0,   66,
    0,    0,   66,   79,   79,   79,    0,    0,    0,    0,
   79,    0,   79,   80,   80,   80,   66,    0,    0,   66,
   80,    0,   80,   79,    0,    0,    0,    0,    0,    0,
   77,   77,   77,   80,    0,    0,   78,   78,   78,   77,
    0,    0,   76,   76,   76,   78,   70,   70,   70,    0,
   77,   76,    0,    0,    0,   70,   78,    0,    0,    0,
    0,    0,   76,   72,   72,   72,   70,    0,    0,   92,
   92,    0,    0,    0,    0,   92,   92,   92,   92,    0,
    0,    0,    0,   72,    0,    0,   74,    0,   74,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   60,   61,   74,    0,    0,    0,
   62,    0,   63,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   60,   61,    0,    0,    0,    0,
   62,    0,   63,    0,    0,    0,   60,   61,    0,    0,
    0,    0,   62,    0,   63,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   60,   61,    0,    0,    0,    0,
   62,    0,   63,   60,   61,    0,   60,   61,   39,   62,
    0,   63,   62,    0,   63,    0,    0,    0,    0,    0,
   60,   61,    0,   60,    0,    0,   62,    0,   63,   62,
    0,   63,   55,   56,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   72,   75,    0,    0,    0,
    0,   77,   78,    0,   81,    0,   83,   84,    0,   87,
    0,    0,    0,    0,    0,    0,    0,   96,   97,   98,
   99,  100,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  112,    0,  115,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  121,
  122,    0,    0,    0,    0,    0,  123,    0,   75,    0,
  126,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   87,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   75,
    0,    0,    0,  112,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  112,
};
short yycheck[] = {                                      40,
   44,   59,   59,   43,   45,   45,   59,   59,   59,   59,
   59,   94,   59,   59,   59,   59,   59,    1,   59,  138,
   41,   41,   41,   44,   41,   44,   40,   44,    2,   40,
   40,  265,   40,  267,  262,  262,  155,   45,   59,   59,
   44,   41,   59,   40,   44,   40,   40,   40,   40,   40,
  278,  279,  280,   91,   94,   40,   44,  285,   40,   40,
  262,   41,   41,   41,   40,   94,   91,  125,  125,   45,
   41,   59,  125,  125,  125,  125,  125,   91,  125,   44,
   91,   91,  123,   57,  125,   44,   70,   59,   93,  123,
  262,  257,   41,   43,  277,   45,  281,   40,   59,   41,
   41,   91,   45,   59,   93,   41,   41,   91,   41,   41,
   41,   59,   41,   41,    7,  123,  148,  154,   92,  118,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,
   -1,   45,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   -1,   -1,  123,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   -1,  131,   -1,   -1,
   45,   -1,   -1,   -1,   -1,   40,  140,   -1,   -1,  125,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  152,   -1,
  123,  264,   -1,   -1,   -1,   -1,   40,   -1,   -1,  163,
   -1,   45,   -1,   -1,   -1,   -1,   40,   -1,   -1,  257,
  257,   45,   -1,   -1,  257,  257,  257,  257,  257,  123,
  257,  257,  257,  257,  257,  256,  257,   -1,   93,  260,
  261,  262,  263,   -1,  264,  277,  267,  277,  269,  270,
  271,  272,  273,  274,  275,  276,  257,  278,  279,  280,
  257,  282,  283,  284,  285,  286,  287,  288,  256,   93,
   -1,   40,  260,  261,  262,  263,   45,   -1,   -1,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  257,
  278,  279,  280,   -1,  282,  283,  284,  285,  286,  287,
  288,  257,   -1,   40,  260,  261,  262,  263,   45,  277,
   -1,  267,   -1,  269,  270,  271,  272,  273,  274,  275,
  276,  257,  278,  279,  280,   -1,  282,  283,  284,  285,
  286,  287,  288,  256,  264,   -1,  266,  260,  261,  262,
  263,  277,   -1,   -1,  267,   -1,  269,  270,  271,  272,
  273,  274,  275,  276,   -1,  278,  279,  280,   -1,  282,
  283,  284,  285,  286,  287,  288,  260,  261,  262,  263,
   -1,   -1,   -1,  267,   -1,  269,  270,  271,  272,  273,
  274,  275,  276,   -1,  278,  279,  280,   -1,  282,  283,
  284,  285,  286,  287,  288,  260,  261,  262,  263,   -1,
   -1,   41,  267,   -1,   44,  260,  271,  262,  263,   -1,
   -1,  276,  267,  278,  279,  280,  271,  282,   -1,   59,
  285,  276,   -1,  278,  279,  280,  260,  282,  262,  263,
  285,   -1,   -1,  267,   -1,   -1,  260,  271,  262,  263,
   -1,   -1,  276,  267,  278,  279,  280,  271,  282,   -1,
   -1,  285,  276,   93,  278,  279,  280,   -1,  282,   -1,
   -1,  285,   41,   -1,   43,   44,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   59,   43,   44,   45,   -1,  125,   -1,   -1,   -1,   -1,
   -1,  260,   -1,  262,  263,   -1,   -1,   59,  267,   -1,
   -1,   41,  271,   43,   44,   45,   -1,  276,   -1,  278,
  279,  280,   -1,  282,   93,   94,  285,   -1,   41,   59,
   43,   44,   45,  260,   -1,  262,  263,   -1,   -1,   -1,
  267,   93,   94,   -1,  271,   -1,   59,   -1,   -1,  276,
   -1,  278,  279,  280,   -1,  282,  125,   41,  285,   43,
   44,   45,   -1,   93,   94,   -1,   -1,   41,   -1,   43,
   44,   45,   -1,  125,   -1,   59,   -1,   -1,   -1,   -1,
   93,   94,   -1,   -1,   41,   59,   43,   44,   45,   -1,
   41,   -1,   43,   44,   45,  125,   41,   -1,   -1,   44,
   41,   -1,   59,   44,   -1,   -1,   -1,   -1,   59,   93,
   -1,   -1,  125,   -1,   59,   -1,   -1,   41,   59,   93,
   44,   -1,   41,   -1,   43,   44,   45,  257,  258,  259,
   -1,   -1,   -1,   -1,   -1,   59,   93,   -1,   -1,   -1,
   41,  125,   93,   44,   -1,   -1,   -1,  277,   93,   -1,
   -1,  125,   93,   -1,   -1,   -1,   -1,   41,   59,   43,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,  125,   93,
   -1,   -1,   -1,   -1,  125,   94,   -1,   41,   -1,   43,
  125,   45,   -1,   -1,  125,   -1,   -1,   -1,  257,  258,
  259,   43,   93,   45,   -1,  264,  265,  266,  267,   -1,
   -1,  125,   -1,   -1,   -1,  257,  258,  259,  277,   43,
   94,   45,  264,  265,  266,  267,   41,   -1,   43,   41,
   45,   43,   -1,   45,  125,  277,   -1,  257,  258,  259,
   94,   -1,   -1,   41,  264,   43,  266,   45,   43,   -1,
   45,   93,   94,   -1,  257,  258,  259,  277,   -1,   -1,
   -1,  264,   -1,  266,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,   94,
   -1,   -1,   94,  257,  258,  259,   -1,   -1,   -1,   -1,
  264,   -1,  266,  257,  258,  259,   94,   -1,   -1,   94,
  264,   -1,  266,  277,   -1,   -1,   -1,   -1,   -1,   -1,
  257,  258,  259,  277,   -1,   -1,  257,  258,  259,  266,
   -1,   -1,  257,  258,  259,  266,  257,  258,  259,   -1,
  277,  266,   -1,   -1,   -1,  266,  277,   -1,   -1,   -1,
   -1,   -1,  277,  257,  258,  259,  277,   -1,   -1,  258,
  259,   -1,   -1,   -1,   -1,  264,  265,  266,  267,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  257,   -1,  259,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  258,  259,  277,   -1,   -1,   -1,
  264,   -1,  266,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  258,  259,   -1,   -1,   -1,   -1,
  264,   -1,  266,   -1,   -1,   -1,  258,  259,   -1,   -1,
   -1,   -1,  264,   -1,  266,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  258,  259,   -1,   -1,   -1,   -1,
  264,   -1,  266,  258,  259,   -1,  258,  259,    3,  264,
   -1,  266,  264,   -1,  266,   -1,   -1,   -1,   -1,   -1,
  258,  259,   -1,  258,   -1,   -1,  264,   -1,  266,  264,
   -1,  266,   27,   28,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   41,   -1,   -1,   -1,
   -1,   46,   47,   -1,   49,   -1,   51,   52,   -1,   54,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   62,   63,   64,
   65,   66,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   80,   -1,   82,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   95,   -1,   -1,   -1,   -1,   -1,  101,   -1,  103,   -1,
  105,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  118,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  134,
   -1,   -1,   -1,  138,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  155,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 289
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'",0,"'+'","','","'-'",0,0,0,0,0,0,0,0,0,0,0,0,0,"';'",0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,"NEWLINE","AND","OR","NOT","STRING","NAME","NUMBER","MUL_OP",
"ASSIGN_OP","REL_OP","INCR_DECR","Define","Break","Quit","Length","Return",
"For","If","While","Sqrt","Else","Scale","Ibase","Obase","Auto","Read",
"Warranty","Halt","Last","Continue","Print","Limits","UNARY_MINUS",
};
char *yyrule[] = {
"$accept : program",
"program :",
"program : program input_item",
"input_item : semicolon_list NEWLINE",
"input_item : function",
"input_item : error NEWLINE",
"semicolon_list :",
"semicolon_list : statement_or_error",
"semicolon_list : semicolon_list ';' statement_or_error",
"semicolon_list : semicolon_list ';'",
"statement_list :",
"statement_list : statement_or_error",
"statement_list : statement_list NEWLINE",
"statement_list : statement_list NEWLINE statement_or_error",
"statement_list : statement_list ';'",
"statement_list : statement_list ';' statement",
"statement_or_error : statement",
"statement_or_error : error statement",
"statement : Warranty",
"statement : Limits",
"statement : expression",
"statement : STRING",
"statement : Break",
"statement : Continue",
"statement : Quit",
"statement : Halt",
"statement : Return",
"statement : Return '(' return_expression ')'",
"$$1 :",
"$$2 :",
"$$3 :",
"$$4 :",
"statement : For $$1 '(' opt_expression ';' $$2 opt_expression ';' $$3 opt_expression ')' $$4 statement",
"$$5 :",
"statement : If '(' expression ')' $$5 statement opt_else",
"$$6 :",
"$$7 :",
"statement : While $$6 '(' expression $$7 ')' statement",
"statement : '{' statement_list '}'",
"$$8 :",
"statement : Print $$8 print_list",
"print_list : print_element",
"print_list : print_element ',' print_list",
"print_element : STRING",
"print_element : expression",
"opt_else :",
"$$9 :",
"opt_else : Else $$9 statement",
"$$10 :",
"function : Define NAME '(' opt_parameter_list ')' '{' NEWLINE opt_auto_define_list $$10 statement_list '}'",
"opt_parameter_list :",
"opt_parameter_list : define_list",
"opt_auto_define_list :",
"opt_auto_define_list : Auto define_list NEWLINE",
"opt_auto_define_list : Auto define_list ';'",
"define_list : NAME",
"define_list : NAME '[' ']'",
"define_list : define_list ',' NAME",
"define_list : define_list ',' NAME '[' ']'",
"opt_argument_list :",
"opt_argument_list : argument_list",
"argument_list : expression",
"argument_list : NAME '[' ']'",
"argument_list : argument_list ',' expression",
"argument_list : argument_list ',' NAME '[' ']'",
"opt_expression :",
"opt_expression : expression",
"return_expression :",
"return_expression : expression",
"$$11 :",
"expression : named_expression ASSIGN_OP $$11 expression",
"$$12 :",
"expression : expression AND $$12 expression",
"$$13 :",
"expression : expression OR $$13 expression",
"expression : NOT expression",
"expression : expression REL_OP expression",
"expression : expression '+' expression",
"expression : expression '-' expression",
"expression : expression MUL_OP expression",
"expression : expression '^' expression",
"expression : '-' expression",
"expression : named_expression",
"expression : NUMBER",
"expression : '(' expression ')'",
"expression : NAME '(' opt_argument_list ')'",
"expression : INCR_DECR named_expression",
"expression : named_expression INCR_DECR",
"expression : Length '(' expression ')'",
"expression : Sqrt '(' expression ')'",
"expression : Scale '(' expression ')'",
"expression : Read '(' ')'",
"named_expression : NAME",
"named_expression : NAME '[' expression ']'",
"named_expression : Ibase",
"named_expression : Obase",
"named_expression : Scale",
"named_expression : Last",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
int yylex(void);
int yyparse(void);
void yyerror(char *);
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 109 "bc.y"
{
			      yyval.i_value = 0;
			      if (interactive)
				{
				  printf ("%s\n", BC_VERSION);
				  welcome ();
				}
			    }
break;
case 3:
#line 120 "bc.y"
{ run_code (); }
break;
case 4:
#line 122 "bc.y"
{ run_code (); }
break;
case 5:
#line 124 "bc.y"
{
			      yyerrok;
			      init_gen ();
			    }
break;
case 6:
#line 130 "bc.y"
{ yyval.i_value = 0; }
break;
case 10:
#line 136 "bc.y"
{ yyval.i_value = 0; }
break;
case 17:
#line 145 "bc.y"
{ yyval.i_value = yyvsp[0].i_value; }
break;
case 18:
#line 148 "bc.y"
{ warranty (""); }
break;
case 19:
#line 150 "bc.y"
{ limits (); }
break;
case 20:
#line 152 "bc.y"
{
			      if (yyvsp[0].i_value & 2)
				bc_warn ("comparison in expression");
			      if (yyvsp[0].i_value & 1)
				generate ("W");
			      else 
				generate ("p");
			    }
break;
case 21:
#line 161 "bc.y"
{
			      yyval.i_value = 0;
			      generate ("w");
			      generate (yyvsp[0].s_value);
			      free (yyvsp[0].s_value);
			    }
break;
case 22:
#line 168 "bc.y"
{
			      if (break_label == 0)
				yyerror ("Break outside a for/while");
			      else
				{
				  sprintf (genstr, "J%1d:", break_label);
				  generate (genstr);
				}
			    }
break;
case 23:
#line 178 "bc.y"
{
			      bc_warn ("Continue statement");
			      if (continue_label == 0)
				yyerror ("Continue outside a for");
			      else
				{
				  sprintf (genstr, "J%1d:", continue_label);
				  generate (genstr);
				}
			    }
break;
case 24:
#line 189 "bc.y"
{ exit (0); }
break;
case 25:
#line 191 "bc.y"
{ generate ("h"); }
break;
case 26:
#line 193 "bc.y"
{ generate ("0R"); }
break;
case 27:
#line 195 "bc.y"
{ generate ("R"); }
break;
case 28:
#line 197 "bc.y"
{
			      yyvsp[0].i_value = break_label; 
			      break_label = next_label++;
			    }
break;
case 29:
#line 202 "bc.y"
{
			      if (yyvsp[-1].i_value > 1)
				bc_warn ("Comparison in first for expression");
			      yyvsp[-1].i_value = next_label++;
			      if (yyvsp[-1].i_value < 0)
				sprintf (genstr, "N%1d:", yyvsp[-1].i_value);
			      else
				sprintf (genstr, "pN%1d:", yyvsp[-1].i_value);
			      generate (genstr);
			    }
break;
case 30:
#line 213 "bc.y"
{
			      if (yyvsp[-1].i_value < 0) generate ("1");
			      yyvsp[-1].i_value = next_label++;
			      sprintf (genstr, "B%1d:J%1d:", yyvsp[-1].i_value, break_label);
			      generate (genstr);
			      yyval.i_value = continue_label;
			      continue_label = next_label++;
			      sprintf (genstr, "N%1d:", continue_label);
			      generate (genstr);
			    }
break;
case 31:
#line 224 "bc.y"
{
			      if (yyvsp[-1].i_value > 1)
				bc_warn ("Comparison in third for expression");
			      if (yyvsp[-1].i_value < 0)
				sprintf (genstr, "J%1d:N%1d:", yyvsp[-7].i_value, yyvsp[-4].i_value);
			      else
				sprintf (genstr, "pJ%1d:N%1d:", yyvsp[-7].i_value, yyvsp[-4].i_value);
			      generate (genstr);
			    }
break;
case 32:
#line 234 "bc.y"
{
			      sprintf (genstr, "J%1d:N%1d:",
				       continue_label, break_label);
			      generate (genstr);
			      break_label = yyvsp[-12].i_value;
			      continue_label = yyvsp[-4].i_value;
			    }
break;
case 33:
#line 242 "bc.y"
{
			      yyvsp[-1].i_value = if_label;
			      if_label = next_label++;
			      sprintf (genstr, "Z%1d:", if_label);
			      generate (genstr);
			    }
break;
case 34:
#line 249 "bc.y"
{
			      sprintf (genstr, "N%1d:", if_label); 
			      generate (genstr);
			      if_label = yyvsp[-4].i_value;
			    }
break;
case 35:
#line 255 "bc.y"
{
			      yyvsp[0].i_value = next_label++;
			      sprintf (genstr, "N%1d:", yyvsp[0].i_value);
			      generate (genstr);
			    }
break;
case 36:
#line 261 "bc.y"
{
			      yyvsp[0].i_value = break_label; 
			      break_label = next_label++;
			      sprintf (genstr, "Z%1d:", break_label);
			      generate (genstr);
			    }
break;
case 37:
#line 268 "bc.y"
{
			      sprintf (genstr, "J%1d:N%1d:", yyvsp[-6].i_value, break_label);
			      generate (genstr);
			      break_label = yyvsp[-3].i_value;
			    }
break;
case 38:
#line 274 "bc.y"
{ yyval.i_value = 0; }
break;
case 39:
#line 276 "bc.y"
{  bc_warn ("print statement"); }
break;
case 43:
#line 283 "bc.y"
{
			      generate ("O");
			      generate (yyvsp[0].s_value);
			      free (yyvsp[0].s_value);
			    }
break;
case 44:
#line 289 "bc.y"
{ generate ("P"); }
break;
case 46:
#line 293 "bc.y"
{
			      bc_warn ("else clause in if statement");
			      yyvsp[0].i_value = next_label++;
			      sprintf (genstr, "J%d:N%1d:", yyvsp[0].i_value, if_label); 
			      generate (genstr);
			      if_label = yyvsp[0].i_value;
			    }
break;
case 48:
#line 303 "bc.y"
{
			      /* Check auto list against parameter list? */
			      check_params (yyvsp[-4].a_value,yyvsp[0].a_value);
			      sprintf (genstr, "F%d,%s.%s[",
				       lookup(yyvsp[-6].s_value,FUNCTDEF), 
				       arg_str (yyvsp[-4].a_value), arg_str (yyvsp[0].a_value));
			      generate (genstr);
			      free_args (yyvsp[-4].a_value);
			      free_args (yyvsp[0].a_value);
			      yyvsp[-7].i_value = next_label;
			      next_label = 1;
			    }
break;
case 49:
#line 316 "bc.y"
{
			      generate ("0R]");
			      next_label = yyvsp[-10].i_value;
			    }
break;
case 50:
#line 322 "bc.y"
{ yyval.a_value = NULL; }
break;
case 52:
#line 326 "bc.y"
{ yyval.a_value = NULL; }
break;
case 53:
#line 328 "bc.y"
{ yyval.a_value = yyvsp[-1].a_value; }
break;
case 54:
#line 330 "bc.y"
{ yyval.a_value = yyvsp[-1].a_value; }
break;
case 55:
#line 333 "bc.y"
{ yyval.a_value = nextarg (NULL, lookup (yyvsp[0].s_value,SIMPLE)); }
break;
case 56:
#line 335 "bc.y"
{ yyval.a_value = nextarg (NULL, lookup (yyvsp[-2].s_value,ARRAY)); }
break;
case 57:
#line 337 "bc.y"
{ yyval.a_value = nextarg (yyvsp[-2].a_value, lookup (yyvsp[0].s_value,SIMPLE)); }
break;
case 58:
#line 339 "bc.y"
{ yyval.a_value = nextarg (yyvsp[-4].a_value, lookup (yyvsp[-2].s_value,ARRAY)); }
break;
case 59:
#line 342 "bc.y"
{ yyval.a_value = NULL; }
break;
case 61:
#line 346 "bc.y"
{
			      if (yyvsp[0].i_value > 1) bc_warn ("comparison in argument");
			      yyval.a_value = nextarg (NULL,0);
			    }
break;
case 62:
#line 351 "bc.y"
{
			      sprintf (genstr, "K%d:", -lookup (yyvsp[-2].s_value,ARRAY));
			      generate (genstr);
			      yyval.a_value = nextarg (NULL,1);
			    }
break;
case 63:
#line 357 "bc.y"
{
			      if (yyvsp[0].i_value > 1) warn ("comparison in argument");
			      yyval.a_value = nextarg (yyvsp[-2].a_value,0);
			    }
break;
case 64:
#line 362 "bc.y"
{
			      sprintf (genstr, "K%d:", -lookup (yyvsp[-2].s_value,ARRAY));
			      generate (genstr);
			      yyval.a_value = nextarg (yyvsp[-4].a_value,1);
			    }
break;
case 65:
#line 369 "bc.y"
{
			      yyval.i_value = -1;
			      bc_warn ("Missing expression in for statement");
			    }
break;
case 67:
#line 376 "bc.y"
{
			      yyval.i_value = 0;
			      generate ("0");
			    }
break;
case 68:
#line 381 "bc.y"
{
			      if (yyvsp[0].i_value > 1)
				bc_warn ("comparison in return expresion");
			    }
break;
case 69:
#line 387 "bc.y"
{
			      if (yyvsp[0].c_value != '=')
				{
				  if (yyvsp[-1].i_value < 0)
				    sprintf (genstr, "DL%d:", -yyvsp[-1].i_value);
				  else
				    sprintf (genstr, "l%d:", yyvsp[-1].i_value);
				  generate (genstr);
				}
			    }
break;
case 70:
#line 398 "bc.y"
{
			      if (yyvsp[0].i_value > 1) bc_warn("comparison in assignment");
			      if (yyvsp[-2].c_value != '=')
				{
				  sprintf (genstr, "%c", yyvsp[-2].c_value);
				  generate (genstr);
				}
			      if (yyvsp[-3].i_value < 0)
				sprintf (genstr, "S%d:", -yyvsp[-3].i_value);
			      else
				sprintf (genstr, "s%d:", yyvsp[-3].i_value);
			      generate (genstr);
			      yyval.i_value = 0;
			    }
break;
case 71:
#line 414 "bc.y"
{
			      bc_warn("&& operator");
			      yyvsp[0].i_value = next_label++;
			      sprintf (genstr, "DZ%d:p", yyvsp[0].i_value);
			      generate (genstr);
			    }
break;
case 72:
#line 421 "bc.y"
{
			      sprintf (genstr, "DZ%d:p1N%d:", yyvsp[-2].i_value, yyvsp[-2].i_value);
			      generate (genstr);
			      yyval.i_value = yyvsp[-3].i_value | yyvsp[0].i_value;
			    }
break;
case 73:
#line 427 "bc.y"
{
			      bc_warn("|| operator");
			      yyvsp[0].i_value = next_label++;
			      sprintf (genstr, "B%d:", yyvsp[0].i_value);
			      generate (genstr);
			    }
break;
case 74:
#line 434 "bc.y"
{
			      int tmplab;
			      tmplab = next_label++;
			      sprintf (genstr, "B%d:0J%d:N%d:1N%d:",
				       yyvsp[-2].i_value, tmplab, yyvsp[-2].i_value, tmplab);
			      generate (genstr);
			      yyval.i_value = yyvsp[-3].i_value | yyvsp[0].i_value;
			    }
break;
case 75:
#line 443 "bc.y"
{
			      yyval.i_value = yyvsp[0].i_value;
			      bc_warn("! operator");
			      generate ("!");
			    }
break;
case 76:
#line 449 "bc.y"
{
			      yyval.i_value = 3;
			      switch (*(yyvsp[-1].s_value))
				{
				case '=':
				  generate ("=");
				  break;

				case '!':
				  generate ("#");
				  break;

				case '<':
				  if (yyvsp[-1].s_value[1] == '=')
				    generate ("{");
				  else
				    generate ("<");
				  break;

				case '>':
				  if (yyvsp[-1].s_value[1] == '=')
				    generate ("}");
				  else
				    generate (">");
				  break;
				}
			    }
break;
case 77:
#line 477 "bc.y"
{
			      generate ("+");
			      yyval.i_value = yyvsp[-2].i_value | yyvsp[0].i_value;
			    }
break;
case 78:
#line 482 "bc.y"
{
			      generate ("-");
			      yyval.i_value = yyvsp[-2].i_value | yyvsp[0].i_value;
			    }
break;
case 79:
#line 487 "bc.y"
{
			      genstr[0] = yyvsp[-1].c_value;
			      genstr[1] = 0;
			      generate (genstr);
			      yyval.i_value = yyvsp[-2].i_value | yyvsp[0].i_value;
			    }
break;
case 80:
#line 494 "bc.y"
{
			      generate ("^");
			      yyval.i_value = yyvsp[-2].i_value | yyvsp[0].i_value;
			    }
break;
case 81:
#line 499 "bc.y"
{
			      generate ("n");
			      yyval.i_value = yyvsp[0].i_value;
			    }
break;
case 82:
#line 504 "bc.y"
{
			      yyval.i_value = 1;
			      if (yyvsp[0].i_value < 0)
				sprintf (genstr, "L%d:", -yyvsp[0].i_value);
			      else
				sprintf (genstr, "l%d:", yyvsp[0].i_value);
			      generate (genstr);
			    }
break;
case 83:
#line 513 "bc.y"
{
			      int len = strlen(yyvsp[0].s_value);
			      yyval.i_value = 1;
			      if (len == 1 && *yyvsp[0].s_value == '0')
				generate ("0");
			      else if (len == 1 && *yyvsp[0].s_value == '1')
				generate ("1");
			      else
				{
				  generate ("K");
				  generate (yyvsp[0].s_value);
				  generate (":");
				}
			      free (yyvsp[0].s_value);
			    }
break;
case 84:
#line 529 "bc.y"
{ yyval.i_value = yyvsp[-1].i_value | 1; }
break;
case 85:
#line 531 "bc.y"
{
			      yyval.i_value = 1;
			      if (yyvsp[-1].a_value != NULL)
				{ 
				  sprintf (genstr, "C%d,%s:",
					   lookup (yyvsp[-3].s_value,FUNCT),
					   call_str (yyvsp[-1].a_value));
				  free_args (yyvsp[-1].a_value);
				}
			      else
				{
				  sprintf (genstr, "C%d:", lookup (yyvsp[-3].s_value,FUNCT));
				}
			      generate (genstr);
			    }
break;
case 86:
#line 547 "bc.y"
{
			      yyval.i_value = 1;
			      if (yyvsp[0].i_value < 0)
				{
				  if (yyvsp[-1].c_value == '+')
				    sprintf (genstr, "DA%d:L%d:", -yyvsp[0].i_value, -yyvsp[0].i_value);
				  else
				    sprintf (genstr, "DM%d:L%d:", -yyvsp[0].i_value, -yyvsp[0].i_value);
				}
			      else
				{
				  if (yyvsp[-1].c_value == '+')
				    sprintf (genstr, "i%d:l%d:", yyvsp[0].i_value, yyvsp[0].i_value);
				  else
				    sprintf (genstr, "d%d:l%d:", yyvsp[0].i_value, yyvsp[0].i_value);
				}
			      generate (genstr);
			    }
break;
case 87:
#line 566 "bc.y"
{
			      yyval.i_value = 1;
			      if (yyvsp[-1].i_value < 0)
				{
				  sprintf (genstr, "DL%d:x", -yyvsp[-1].i_value);
				  generate (genstr); 
				  if (yyvsp[0].c_value == '+')
				    sprintf (genstr, "A%d:", -yyvsp[-1].i_value);
				  else
				      sprintf (genstr, "M%d:", -yyvsp[-1].i_value);
				}
			      else
				{
				  sprintf (genstr, "l%d:", yyvsp[-1].i_value);
				  generate (genstr);
				  if (yyvsp[0].c_value == '+')
				    sprintf (genstr, "i%d:", yyvsp[-1].i_value);
				  else
				    sprintf (genstr, "d%d:", yyvsp[-1].i_value);
				}
			      generate (genstr);
			    }
break;
case 88:
#line 589 "bc.y"
{ generate ("cL"); yyval.i_value = 1;}
break;
case 89:
#line 591 "bc.y"
{ generate ("cR"); yyval.i_value = 1;}
break;
case 90:
#line 593 "bc.y"
{ generate ("cS"); yyval.i_value = 1;}
break;
case 91:
#line 595 "bc.y"
{
			      bc_warn ("read function");
			      generate ("cI"); yyval.i_value = 1;
			    }
break;
case 92:
#line 601 "bc.y"
{ yyval.i_value = lookup(yyvsp[0].s_value,SIMPLE); }
break;
case 93:
#line 603 "bc.y"
{
			      if (yyvsp[-1].i_value > 1) bc_warn("comparison in subscript");
			      yyval.i_value = lookup(yyvsp[-3].s_value,ARRAY);
			    }
break;
case 94:
#line 608 "bc.y"
{ yyval.i_value = 0; }
break;
case 95:
#line 610 "bc.y"
{ yyval.i_value = 1; }
break;
case 96:
#line 612 "bc.y"
{ yyval.i_value = 2; }
break;
case 97:
#line 614 "bc.y"
{ yyval.i_value = 3;
			      bc_warn ("Last variable");
			    }
break;
#line 1310 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
